unit Otimi;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ComCtrls,
  StdCtrls, Buttons, fpimage, principal;

type

  { TOtimizar }

    TOtimizar = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    UpDown1: TUpDown;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Otimizar: TOtimizar;


implementation

{ TOtimizar }

procedure TOtimizar.Button1Click(Sender: TObject);
var
Pcor : TFPColor;        // cor do ponto
x  : integer;
y  : integer;
xi : integer;
xf : integer;
yi : integer;
yf : integer;
vxyi : boolean;
BR : integer;

begin
 vxyi := false;
 for x := 0 to Form1.image1.Picture.Bitmap.Width do
 begin
  for y := 0 to Form1.image1.picture.bitmap.height do
  begin
   Pcor := Form1.image1.Picture.Bitmap.Canvas.Colors[x,y];
   BR := Pcor.red + Pcor.green + Pcor.blue;
   if (BR < 10) then
    Begin
     if not vxyi then
     Begin
      xi := x - 1;
      vxyi := true;
     end
     else
      xf := x + 1;
    end;
   end;
 end;
 vxyi := false;
 for y := 0 to Form1.image1.Picture.Bitmap.Height do
 begin
  for x := 0 to Form1.image1.picture.bitmap.Width do
  begin
   Pcor := Form1.image1.Picture.Bitmap.Canvas.Colors[x,y];
   BR := Pcor.red + Pcor.green + Pcor.blue;
   if (BR < 10) then
    Begin
     if not vxyi then
     Begin
      yi := y - 1;
      vxyi := true;
     end
     else
      yf := y + 1;
    end;
   end;
 end;
 Form1.Image2.Picture.Bitmap.Width := (xf - xi + 1);
 Form1.Image2.Picture.Bitmap.Height := (yf - yi + 1);
 for x := 0 to Form1.image1.Picture.Bitmap.Width do
 begin
  for y := 0 to Form1.image1.picture.bitmap.height do
  begin
   Pcor := Form1.image1.Picture.Bitmap.Canvas.Colors[x,y];
   BR := Pcor.red + Pcor.green + Pcor.blue;
   if (BR < (UpDown1.Position * 8000)) then
    Form1.image2.Canvas.Pixels[(x - xi),(y - yi)] := CLblack
   else
    Form1.image2.Canvas.Pixels[(x - xi),(y - yi)] := CLWhite;
  end;
 end;
 form1.Image2.Update;
 form1.Image2.Refresh;
end;

procedure TOtimizar.Button2Click(Sender: TObject);
begin
  Otimizar.Close;
end;

procedure TOtimizar.FormShow(Sender: TObject);
begin
  label2.Caption := inttostr(updown1.Position);
  form1.Notebook1.PageIndex := 1;
end;




procedure TOtimizar.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
 label2.Caption := inttostr(updown1.Position);
end;


initialization
  {$I otimi.lrs}

end.

