unit Medi;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Buttons, principal, ComCtrls;

type

  { TMedida }

  TMedida = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    UpDown1: TUpDown;
    UpDown2: TUpDown;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure UpDown2Click(Sender: TObject; Button: TUDBtnType);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Medida: TMedida;

implementation

{ TMedida }

procedure TMedida.FormShow(Sender: TObject);
begin
  image1.Picture.Bitmap := form1.Image2.Picture.Bitmap;
end;

procedure TMedida.Button1Click(Sender: TObject);
begin
  tx := (image1.Picture.Bitmap.Width / UpDown1.Position);
  ty := (image1.Picture.Bitmap.Height / UpDown2.Position);
  showmessage('Resoluo do eixo X  de ' + formatfloat('###.00',tx) + ' pontos por mm');
  showmessage('Resoluo do eixo Y  de ' + formatfloat('###.00',ty) + ' pontos por mm');
  Medida.Close;
end;

procedure TMedida.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  edit1.Caption := floattostr(UpDown1.Position / 10);
end;

procedure TMedida.UpDown2Click(Sender: TObject; Button: TUDBtnType);
begin
  edit2.Caption := floattostr(UpDown2.Position / 10);
end;

initialization
  {$I medi.lrs}

end.

